前三章介绍了各种选择器，主要介绍的是列表文本转树形结构的图形

# 更多处理器

## 处理器类别

旧版的处理器只有两种类别：文本->文本 和 文本->界面（也叫文本和渲染处理器），
插件 v1.3.0 添加了 界面->界面 的处理器类别（装饰处理器）。
相较于没有装饰处理器的旧版本，有装饰器管理器后更灵活，可以对已经成型的页面元素进行二次修改

其中：如果对文本处理器直接使用装饰处理器，默认会自动先对文本进行一个 `md渲染处理器`

[list2mermaid]
- 文本--文本处理器-->文本
- 文本--渲染处理器-->界面
- 界面--装饰处理器-->界面

## 装饰处理器

### 块名

**这个相当有用**
给块一个名字，并且可以自动识别修饰的块的类型。可以很轻易地：
- 给表格添加| 居中的表格标题
- 给代码添加| 文件名

#### 表格标题

[2table|#表格标题]
- 1| 2
- 3| 4

#### 代码标题

按道理这里的文件名应该和代码块同色，不同色的话自己先在css文件里调一下。
找 `--pre-background-color` ，在css文件的前五行，改个颜色值就行。
（本来想尝试用js获取代码块颜色再调的，但失败了）
[#main.cpp]
```c
#include <stdio.h>
 
int main()
{
    /* 我的第一个 C 程序 */
    printf("Hello, World! \n");
 
    return 0;
}

```

#### 其他标题

[#引用块]
> 引用块1
> 引用块2

[#列表块标题]
- 1
	- 2
		- 3
	- 2


### 折叠

这个是我在写 anyblock 之前，使用dataviewjs强行模拟 list2table 效果的代码
[fold]
```js
const keyword = "%"+"toTable" // 不能合并
const files = app.vault.getMarkdownFiles()


const lines = files
	.filter((file) => {  // 本篇笔记
		return file.path == dv.current().file.path
	})
	.map(async (file) => {  // 转列表
		const content = await app.vault.cachedRead(file)  
		const lines = content.split("\n")
		return lines
	})
	
Promise.all(lines).then(linesTmp => {
	let lines = linesTmp.flat()

	// 先搜索关键词
	let index = 0
	for(let i=0; i<lines.length; i++){
		if(lines[i].contains(keyword)){
			index = i
			break
		}
	}
	
	// 获取参数
	const args = lines[index].replace(keyword, "").replace(/^|/, "").split("|")
	

	// 先不考虑异常缩进了
	let levelArr = []
	let contentArr = []
	for(let i=index+1; i<lines.length; i++){
		if(/^\s*?-\s(.*?)/.test(lines[i])){
			contentArr.push(lines[i].replace(/^\s*?-\s/, ""))
			levelArr.push(lines[i].replace(/-\s(.*?)$/, "").length/2)
		}
		else{
			break
		}
	}

	// 再弄成正确的层次关系，暂时先只考虑三层
	let tableData = []
	let lastArr = []
	let lastLevel = 0
	for(let i=0; i<levelArr.length; i++){
		if(levelArr[i]==0){
			if(lastArr.length!=0) {// 是否不为第一个数据
				tableData.push(lastArr)
				lastArr = []
			}
			lastLevel = 0
			lastArr.push(contentArr[i])
		}
		else if(levelArr[i]==1){
			if (lastLevel<1){ // 是否新起一行
				lastArr.push(contentArr[i])
				lastLevel = 1
			}
			else{
				tableData.push(lastArr)
				lastArr = []
				lastLevel = 1
				lastArr.push("^^")
				lastArr.push(contentArr[i])
			}
		}
		else if(levelArr[i]==2){
			if (lastLevel<2){ // 是否新起一行
				lastArr.push(contentArr[i])
				lastLevel = 2
			}
			else{
				tableData.push(lastArr)
				lastArr = []
				lastLevel = 2
				lastArr.push("^^")
				lastArr.push("^^")
				lastArr.push(contentArr[i])
			}
		}
	}
	tableData.push(lastArr)
	lastArr = []
	
	console.log(tableData)
	dv.table(args, tableData)
})  



```

### 滚动

默认是超出460px滚动，该处理器也可以接受参数，`scroll(超出多少变为滚动)`，参数不需要加 `px`
[scroll]
```js
const keyword = "%"+"toTable" // 不能合并
const files = app.vault.getMarkdownFiles()


const lines = files
	.filter((file) => {  // 本篇笔记
		return file.path == dv.current().file.path
	})
	.map(async (file) => {  // 转列表
		const content = await app.vault.cachedRead(file)  
		const lines = content.split("\n")
		return lines
	})
	
Promise.all(lines).then(linesTmp => {
	let lines = linesTmp.flat()

	// 先搜索关键词
	let index = 0
	for(let i=0; i<lines.length; i++){
		if(lines[i].contains(keyword)){
			index = i
			break
		}
	}
	
	// 获取参数
	const args = lines[index].replace(keyword, "").replace(/^|/, "").split("|")
	

	// 先不考虑异常缩进了
	let levelArr = []
	let contentArr = []
	for(let i=index+1; i<lines.length; i++){
		if(/^\s*?-\s(.*?)/.test(lines[i])){
			contentArr.push(lines[i].replace(/^\s*?-\s/, ""))
			levelArr.push(lines[i].replace(/-\s(.*?)$/, "").length/2)
		}
		else{
			break
		}
	}

	// 再弄成正确的层次关系，暂时先只考虑三层
	let tableData = []
	let lastArr = []
	let lastLevel = 0
	for(let i=0; i<levelArr.length; i++){
		if(levelArr[i]==0){
			if(lastArr.length!=0) {// 是否不为第一个数据
				tableData.push(lastArr)
				lastArr = []
			}
			lastLevel = 0
			lastArr.push(contentArr[i])
		}
		else if(levelArr[i]==1){
			if (lastLevel<1){ // 是否新起一行
				lastArr.push(contentArr[i])
				lastLevel = 1
			}
			else{
				tableData.push(lastArr)
				lastArr = []
				lastLevel = 1
				lastArr.push("^^")
				lastArr.push(contentArr[i])
			}
		}
		else if(levelArr[i]==2){
			if (lastLevel<2){ // 是否新起一行
				lastArr.push(contentArr[i])
				lastLevel = 2
			}
			else{
				tableData.push(lastArr)
				lastArr = []
				lastLevel = 2
				lastArr.push("^^")
				lastArr.push("^^")
				lastArr.push(contentArr[i])
			}
		}
	}
	tableData.push(lastArr)
	lastArr = []
	
	console.log(tableData)
	dv.table(args, tableData)
})  



```
### 黑幕

和萌娘百科的黑幕效果类似
[X|addClass(ab-deco-heimu)]
> 这是一段不能被直接看到的内容
> ...
> ...
> （你是不是看到了？你知道太多了！ [猫猫刀口舔血.jpg]）
### 增加class

addClass(将当前块增加一个类名)、addDiv(增加一个父元素，并给父元素增加一个类名)
这个可以用来让块增添一个自定义样式（像ad插件那样），可供会CSS的用户扩展

# 自定义处理器

推荐几个处理器配置就知道怎么用。
id和mame都是随便填，下面给个演示

[2table]
- 注册器匹配名（可以是中文名）| 注册器替换为
- 引用|     add([!quote])|quote
- 折叠|     add([!note]-|qutoe)
- `/导图(.*?)/`| rootlist(%1)|mindmap
其中，`%n` 表示将正则中的第n个匹配项替换到该位置
例如上面的导图例子中，`导图(主题名)` 就会变成 `rootlist(主题名)|mindmap`

功能和内置的有差距，但通过组合注册器，依然能够做出不错的自定义效果

